
/* this code is an extract of several string functions from the string.c
 * file found in the uClibc distribution. The original author copyright:
 */

/* Copyright (C) 1995,1996 Robert de Bath <rdebath@cix.compulink.co.uk>
 * This file is part of the Linux-8086 C library and is distributed
 * under the GNU Library General Public License.
 */

#include "baselib.h"

int memcmp (const void *s1, const void *s2, unsigned long l)
{
	unsigned char *c1 = (unsigned char *) s1;
	unsigned char *c2 = (unsigned char *) s2;

	while (l--) {
		if (*c1 != *c2)
			return *c1 - *c2;
		c1++;
		c2++;
	}
	return 0;
}
